#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
##########################################################################
Программа: Fpyprog
Цель: изучение Python
Версия: 1.11
Автор: Ф.И.Белялов
Обновления: http://webmed.irkutsk.ru/program.htm
##########################################################################
"""

from tkinter import *
from tkinter import filedialog
import tkinter as tk
import tkinter.messagebox
import tkinter.ttk as ttk

from PIL import Image, ImageTk
import wx
import wx.grid as gridlib
import os
import sys
import configparser
import webbrowser
import re

import sqlite3
import sqlite3 as sqlite
from xlrd import *
from matplotlib.backends.backend_tkagg import FigureCanvasTkAgg
import matplotlib.pyplot as plt
from matplotlib import style
from mpl_toolkits import mplot3d

from numpy import *
import numpy as np
from statistics import mean, median
from scipy.stats import ttest_ind
from scipy.stats import spearmanr
from scipy.stats import pearsonr
from sklearn.cluster import KMeans
from sklearn.cluster import MeanShift

"""
1. Если не запускается из командной строки, обычно не установлены библиотеки (в PyCharm свои экземпляры)
2. Чтобы запустить программу на другом компьютере установи Python и библиотеки.
3. Библиотеки в Python установить pip install wxpython/pandas/matplotlib через командную строку TC
из каталога Compiler/Python/Python37/Scripts/ (не видит, хотя прописано в PATH).
4. Если переименовать файл из *.py в *.pyw, то при запуске не будет вылазить пустая консоль.
5. Комментарии на отдельной строке - сообщение об ошибке выводит всю строку. 
"""
# Глобальные переменные, обращатьс global var, var = ...
# arglob = [1,2,3,4,5,6] #Можно вместо файла хранить в глобальной переменной

# очистки основного окна
isclear = False
# сохранение графики в файле
savegrfile = False
# пропуски
vast = -999.0
ver = '1.11'
date1 = '6.08.2019'
# последовательная нумерация файлов с графикой, чтобы не переписать
plotnmb = 0

def printlog(*args, **kwargs):
    print(*args, **kwargs)

    with open('output.txt', 'a') as file:
        print(*args, **kwargs, file=file)


class TextOut(tk.Text):
    #Устанавливает sys.stdout (вывод на консоль в Python) на экземпляр подкласса.
    def write(self, s):
        global isclear
        if isclear:
            # Очищаем
            self.delete('1.0', END)
        else:
            # Пишем с первой строки, иначе вклинивается в середину
            self.insert('1.0', s)

    def flush(self):
        pass

#------------------------
def fileopen():
    # Везде так создают неосновные окна, основное Tk одно.
    wind = Toplevel()
    # Скрываем пустое окно
    wind.withdraw()
    file_dir = os.path.dirname(os.path.abspath(__file__)) + '\data'
    wind.filename = filedialog.askopenfilename(initialdir=file_dir,title='Select file',filetypes=(('all files', '*.*'), ('sqlite files', '*.sqlite')))
    f = wind.filename
    file_name, file_extension = os.path.splitext(f)

    if file_name!='':
        tempar = np.array([],dtype=float32)
        # SQLite
        if file_extension=='.sqlite' or file_extension=='.mb':
            conn = sqlite3.connect(f)
            cursor = conn.cursor()
            # tail - файл без пути
            head, tail = os.path.split(f)

            # Get List of Tables:
            tableListQuery = "SELECT name FROM sqlite_master WHERE type='table' ORDER BY Name"
            cursor.execute(tableListQuery)
            tables = map(lambda t: t[0], cursor.fetchall())

            # Выбираем базу данных
            wind1 = Toplevel()
            wind1.title('Таблицы')
            wind1.resizable(False, False)
            w = wind1.winfo_screenwidth() // 2 - 300
            h = wind1.winfo_screenheight() // 2 - 50
            wind1.geometry('140x200+{}+{}'.format(w, h))

            listbox = Listbox(wind1)
            tablesToIgnore = ["sqlite_sequence"]
            for table in tables:
                if table in tablesToIgnore:
                    continue
                listbox.insert(END, table)

            listbox.pack()

            def quit1():
                wind1.withdraw()
                # если вместо quit - destroy, то закрывается все, causes mainloop to exit.
                wind1.quit()

            Button(wind1, text="Select table", command=quit1).pack(expand=YES, fill=X)  # Иначе не выйти с выбором
            wind1.mainloop()
            tb0 = [listbox.get(idx) for idx in listbox.curselection()]
            tbl = ''.join(tb0)  # в string

            a = []
            logins = cursor.execute('select * from ' + tbl)
            # Иначе считывает нумерацию ключевого поля и переходит к соответствующей строке грида!!!
            ri = -1
            for row in logins:
                a.append([])
                ri = ri + 1
                cells = row[1:]
                ncell = len(cells)
                for i in range(0, ncell):
                    n = cells[i]
                    # Проблема в том, что программа не знает, что пустое поле числовое
                    # и пропускает его. Поэтому лучше вначале сделать файл данных из БД.
                    if (type(n) == int) or (type(n) == float):
                        if (n is None) or (n is "null"):
                            a[ri].append(vast)
                        else:
                            a[ri].append(cells[i])

            # преобразуем ряды и строки
            b = np.array(a)
            tempar = b.transpose()

        # Excel
        elif file_extension == '.xls' or file_extension == '.xlsx':
            """
            df = pd.read_excel('data.xlsx', sheet_name=0)
            print(df)        
            """
            a = []
            wb = open_workbook(f)
            s = wb.sheet_by_index(0)
            for col in range(s.ncols):
                values = []
                for row in range(s.nrows):
                    c = s.cell(row, col).value
                    if (type(c) == int) or (type(c) == float):
                        values.append(c)
                # если пустой ряд нечисловой []
                if len(values) > 0:
                    a.append(values)
            b = np.array(a)
            tempar = b
        else:
            # считывает в 2-мерный массив float. x, y, z = loadtxt(f, unpack=True)  в 3 массива float
            a = loadtxt(f)
            b = np.array(a)
            # преобразуем ряды и строки
            tempar = b.transpose()

        # иначе может ПОКАЗАТЬ как 3.74000000e+00
        np.set_printoptions(suppress=True, formatter={'float_kind':'{:0.2f}'.format})
        # переводим во float, иначе с int могут быть ошибки
        ar=tempar.astype(float)
        # Выводит весь массив
        np.set_printoptions(threshold=sys.maxsize)
        global isclear
        isclear = False
        printlog()
        # на консоль и в файл
        printlog(ar)

        # сохраняем данные в своем формате и потом данные из файла используются для расчетов
        # ранее было в другом типе файла
        """
        with open('array.txt', 'wb') as fp:
            pickle.dump(ar, fp)
            
        with open('array.txt', 'rb') as fp:
            sa = pickle.load(fp)  #массив
        a1 = np.array(sa)  #переводит list в array
        """
        np.save('array.npy', ar)

# ------------------------
def fileopen1():
    file_dir = os.path.dirname(os.path.abspath(__file__))

    wind = Toplevel()
    # Скрываем пустое окно
    wind.withdraw()
    wind.filename = filedialog.askopenfilename(initialdir=file_dir, title='Select file', filetypes=(('all files','*.*'), ('sqlite files','*.sqlite')))
    os.startfile(wind.filename)

# ------------------------
def deleteoutliers():
    a1 = np.load('array.npy')
    newa1 = a1
    nc = newa1.ndim+1
    nr = newa1.size//nc

    for i in range(nc):
        meangrade = newa1[i,:].mean()
        stdgrade = newa1[i,:].std()
        toprange = meangrade + stdgrade * 1.96
        botrange = meangrade - stdgrade * 1.96

        for j in range(nr):
            dat = newa1[i,j]
            if (dat >= toprange) or (dat <= botrange):
                newa1[i,j] = "{0:.2f}".format(meangrade)

    global isclear
    isclear = False
    # пустая строка
    printlog()
    # на консоль
    printlog(newa1)
    np.save('array.npy', newa1)

# ------------------------
def deletevast():
    a1 = np.load('array.npy')
    newa1 = a1
    nc = newa1.ndim+1
    nr = newa1.size//nc

    global vast
    vast1 = float(vast)
    for i in range(nc):
        meangrade = newa1[i,:].mean()
        for j in range(nr):
            dat = newa1[i,j]
            # math.isclose точнее, чем np.isclose
            if math.isclose(dat, vast1, rel_tol=1e-09, abs_tol=0.0):
                newa1[i,j] = "{0:.2f}".format(meangrade)

    global isclear
    isclear = False
    # пустая строка
    printlog()
    # на консоль
    printlog(newa1)
    np.save('array.npy', newa1)

# ------------------------
def datafileopen():
    a1 = np.load('array.npy')

    np.set_printoptions(suppress=True, formatter={'float_kind':'{:0.2f}'.format}) #иначе может ПОКАЗАТЬ как 3.74000000e+00
    #Выводит весь массив
    np.set_printoptions(threshold=sys.maxsize)
    global isclear
    isclear = False
    # пустая строка
    printlog()
    # на консоль
    printlog(a1)

#------------------------
def dbinfo():
    file_dir = os.path.dirname(os.path.abspath( __file__ ))+'\data'

    wind = Toplevel()
    # Скрываем пустое окно
    wind.withdraw()
    wind.filename =  filedialog.askopenfilename(initialdir = file_dir,title = 'Select file',filetypes = (('all files', '*.*'), ('sqlite files', '*.sqlite')))
    f = wind.filename

    if f!='':
        connection = sqlite.connect(f)
        cursor = connection.cursor()

        tablesToIgnore = ["sqlite_sequence"]

        # Get List of Tables:
        tableListQuery = "SELECT name FROM sqlite_master WHERE type='table' ORDER BY Name"
        cursor.execute(tableListQuery)
        tables = map(lambda t: t[0], cursor.fetchall())

        global isclear
        isclear = False
        # пустая строка
        printlog()
        for table in tables:
            if table in tablesToIgnore:
                continue

            columnsQuery = "PRAGMA table_info(%s)" % table
            cursor.execute(columnsQuery)
            numberOfColumns = len(cursor.fetchall())

            rowsQuery = "SELECT Count() FROM %s" % table
            cursor.execute(rowsQuery)
            numberOfRows = cursor.fetchone()[0]

            #%d is the formatting option for signed decimal integers, and %s is for strings
            printlog("%s\t\t%d\t\t%d" % (table, numberOfColumns, numberOfRows))

        printlog("TableName\t\tColumns\t\tRows") #\t is used for TAB character
        cursor.close()
        connection.close()

        wind.mainloop()

#========================
def curarray():
    sa = np.load('array.npy')
    # иначе может ПОКАЗАТЬ как 3.74000000e+00
    np.set_printoptions(suppress=True, formatter={'float_kind': '{:0.2f}'.format})
    # Выводит весь массив
    np.set_printoptions(threshold=sys.maxsize)
    global isclear
    isclear = False
    # пустая строка
    printlog()
    printlog(sa)

# ---------Выбираем переменные------------
varlist = ()
def currvar(numcols1, one, nmbselect):
    wind = Toplevel()
    ns0 = 'Выбор N '+ nmbselect
    wind.title(ns0)
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 300
    h = wind.winfo_screenheight() // 2 - 50
    wind.geometry('140x200+{}+{}'.format(w, h))

    if one:
        lb = Listbox(wind, selectmode=SINGLE)  # create Listbox
    else:
        lb = Listbox(wind, selectmode=MULTIPLE, exportselection=0)

    for n in range(numcols1):
        vr = 'var_'+str(n)
        # put nums 0-4 in listbox
        lb.insert(END, vr)
    # put listbox on window
    lb.pack()

    def quit1():
        wind.withdraw()
        # causes mainloop to exit.
        wind.quit()

    ns = "Выбрать: N" + nmbselect
    Button(wind, text=ns, command=quit1).pack(expand=YES, fill=X)  # Иначе не выйти с выбором
    wind.mainloop()

    # список выбора (0, 2, 4...)
    cnmb = lb.curselection()

    global varlist
    varlist = [lb.get(idx) for idx in lb.curselection()]
    return cnmb

# ------------------------
def statistics():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, True, "1")
    # выбирает 1 столбец
    a = a1[clnmb[0],:]
    len1 = len(a)
    result = ' Число значений: ' + str(len1)

    av = mean(a)
    av1 = "{0:.2f}".format(av)
    result1 = ' Среднее: ' + str(av1)

    md = median(a)
    md2 = "{0:.2f}".format(md)
    result2 = ' Медиана: ' + str(md2)

    sd = std(a)
    sd1 = "{0:.2f}".format(sd)
    result3 = ' Стандартное отклонение: ' + str(sd1)

    max1 = max(a)
    max2 = "{0:.2f}".format(max1)
    result4 = ' Максимум: ' + str(max2)

    min1 = min(a)
    min2 = "{0:.2f}".format(min1)
    result5 = ' Минимум: ' + str(min2)

    suma = sum(a)
    suma1 = "{0:.2f}".format(suma)
    result6 = ' Сумма: ' + str(suma1)

    global isclear
    isclear = False
    resultfull = result+'\n'+result1+'\n'+result2+'\n'+result3+'\n'+result4+'\n'+result5+'\n'+result6

    printlog()
    printlog(resultfull)
    global varlist
    # список выбора (var_0, var_2...)
    vlist = ' Переменные: '+ ', '.join(varlist)
    printlog(vlist)

# ------------------------
def pearson():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "2")
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = pearsonr(a1[clnmb[0], :], a1[clnmb[1], :])

        cf = "{0:.2f}".format(corr)
        if p_value<0.0001:
            p = '<0.0001'
        else:
            p = "{0:.3f}".format(p_value)


        result = ' Коэффициент Pearson: ' + str(cf)
        result1 = ' p: ' + str(p)

        resultfull = result + '\n' + result1

        global isclear
        isclear = False
        # пустая строка
        printlog()
        printlog(resultfull)
        global varlist
        # список выбора (var_0, var_2...)
        vlist = ' Переменные: ' + ', '.join(varlist)
        printlog(vlist)

# ------------------------
def spearmen():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "2")
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = spearmanr(a1[clnmb[0],:], a1[clnmb[1],:])

        cf = "{0:.2f}".format(corr)
        if p_value<0.0001:
            p = '<0.0001'
        else:
            p = "{0:.3f}".format(p_value)

        result = ' Коэффициент Spearman: ' + str(cf)
        result1 = ' p: ' + str(p)

        resultfull = result+'\n'+result1

        global isclear
        isclear = False
        # пустая строка
        printlog()
        printlog(resultfull)
        global varlist
        # список выбора (var_0, var_2...)
        vlist = ' Переменные: ' + ', '.join(varlist)
        printlog(vlist)

# ------------------------
def student():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "2")
    nc = len(clnmb)
    if nc == 2:
        corr, p_value = ttest_ind(a1[clnmb[0],:], a1[clnmb[1],:])

        cf = "{0:.2f}".format(corr)
        if p_value<0.0001:
            p = '<0.0001'
        else:
            p = "{0:.3f}".format(p_value)

        result = ' t-тест Student: ' + str(cf)
        result1 = ' p: ' + str(p)

        av1 = mean(a1[clnmb[0],:])
        av1f = "{0:.2f}".format(av1)
        av2 = mean(a1[clnmb[1],:])
        av2f = "{0:.2f}".format(av2)

        resultfull = result + '\n' + result1

        printlog()  # пустая строка
        global varlist
        st1 = ' Cреднее ' + varlist[0] + ': ' + av1f
        st2 = ' Cреднее ' + varlist[1] + ': ' + av2f
        printlog(st1)
        printlog(st2)

        global isclear
        isclear = False
        printlog(resultfull)

#=========================
def cluster():
    # ---------Настройки------------
    def clustersetup():
        # с Toplevel() не работает wind4.configure(cursor="wait")
        wind = Toplevel()
        wind.title('Настройки')
        wind.resizable(False, False)
        w = wind.winfo_screenwidth() // 2 - 300
        h = wind.winfo_screenheight() // 2 - 50
        wind.geometry('200x170+{}+{}'.format(w, h))

        def quit1():
            global selection
            selection = var.get()
            wind.withdraw()
            # causes mainloop to exit.
            wind.quit()

        cln = '4'
        Label(wind, text='').grid(row=0)
        Label(wind, text='Число кластеров: ').grid(row=1, sticky=W)
        ent1 = Entry(wind, width=4)
        ent1.grid(row=1, column=1)
        ent1.insert(10, cln)

        clsel = '1'
        var = IntVar()
        var.set(1)
        Label(wind, text='Метод группировки данных:').grid(row=2, sticky=W)
        Radiobutton(wind, text='Метод К-средних', variable=var, value=1).grid(row=3, sticky=W)
        Radiobutton(wind, text='Сдвиг среднего значения', variable=var, value=2).grid(row=4, sticky=W)

        Label(wind, text='').grid(row=5)
        Button(wind, text='Ввод данных', command=quit1).grid(row=6, columnspan=2)

        wind.mainloop()
        if selection == 1:
            clsel = '1'
        elif selection == 2:
            clsel = '2'

        cln = ent1.get()
        return cln + ',' + clsel

    a1 = np.load('array.npy')
    numcols = len(a1)
    clnmb = currvar(numcols, False, ">1")
    nc = len(clnmb)

    sel = clustersetup()

    if nc > 1:
        wind4 = Toplevel()
        wind4.resizable(True, True)
        w = wind4.winfo_screenwidth() // 2 - 380
        h = wind4.winfo_screenheight() // 2 - 220
        wind4.geometry('700x600+{}+{}'.format(w, h))

        global varlist
        fig = plt.figure()
        # Очистка, иначе может нарисовать другой график
        plt.clf()

        # иначе может ПОКАЗАТЬ как 3.74000000e+00
        np.set_printoptions(suppress=True, formatter={'float_kind': '{:0.2f}'.format})
        X = a1.transpose()
        clmethod = sel[2]
        clnumber = sel[0]

        if clmethod=='1':
            clmeth = ' Кластерный анализ методом К-средних'
            wind4.title(clmeth)
            kmeans = KMeans(n_clusters=int(clnumber))
            kmeans.fit(X)
            y_kmeans = kmeans.predict(X)
            # реализовано для 2 переменных
            plt.scatter(X[:, clnmb[0], ], X[:, clnmb[1], ], c=y_kmeans, s=50, cmap='viridis')
            centers = kmeans.cluster_centers_
            plt.scatter(centers[:, 0], centers[:, 1], c='black', s=200, alpha=0.5)
        else:
            clmeth = ' Кластерный анализ методом cдвига среднего'
            wind4.title(clmeth)
            ms = MeanShift()
            ms.fit(X)
            labels = ms.labels_
            cluster_centers = ms.cluster_centers_
            printlog()
            printlog(cluster_centers)
            # определяет число кластеров
            clnumber = len(np.unique(labels))

            colors = 10 * ['r.', 'g.', 'b.', 'c.', 'k.', 'y.', 'm.']
            for i in range(len(X)):
                plt.plot(X[i][0], X[i][1], colors[labels[i]], markersize=10)
            plt.scatter(cluster_centers[:, 0], cluster_centers[:, 1],
                        marker="x", color='k', s=150, linewidths=5, zorder=10)

        plt.tight_layout()
        canvas4 = FigureCanvasTkAgg(fig, master=wind4)
        plot_widget4 = canvas4.get_tk_widget()
        plot_widget4.pack(expand=True, fill=BOTH)

        global plotnmb
        plotnmb = plotnmb +1
        if savegrfile:
            fig.savefig('cluster{}.png'.format(plotnmb))
        plt.close("all")

        printlog()
        ncl = ' Число кластеров: ' + str(clnumber)
        printlog(ncl)
        global varlist
        # список выбора (var_0, var_2...)
        vlist = ' Переменные: ' + ', '.join(varlist)
        printlog(vlist)
        printlog(clmeth)

        wind4.mainloop()

# ===========================
def gr_hystogr():
    a1 = np.load('array.npy')
    numcols = len(a1)
    # окно выбора переменных
    clnmb = currvar(numcols, False, "1-4")
    nc = len(clnmb)

    wind1 = Toplevel()
    wind1.title('Гистограмма')
    wind1.resizable(True, True)
    w = wind1.winfo_screenwidth() // 2 - 380
    h = wind1.winfo_screenheight() // 2 - 220
    wind1.geometry('700x600+{}+{}'.format(w, h))

    global varlist
    fig1 = plt.figure()
    # Очистка, иначе может нарисовать другой график
    plt.clf()

    #4 графика одновременно
    if nc>1: 
        for n in range(nc):
            if n==0:
                plt.subplot(2, 2, 1)
                plt.hist(a1[clnmb[n],:], 10)
                plt.ylabel(varlist[0])
            elif n==1:
                plt.subplot(2, 2, 2)
                plt.hist(a1[clnmb[n],:], 10)
                plt.ylabel(varlist[1])
            elif n==2:
                plt.subplot(2, 2, 3)
                plt.hist(a1[clnmb[n],:], 10)
                plt.ylabel(varlist[2])
            elif n==3:
                plt.subplot(2, 2, 4)
                plt.hist(a1[clnmb[n],:], 10)
                plt.ylabel(varlist[3])
            else:
                pass
    # 1 график на все окно
    elif nc==1:
        # plt.style.use('ggplot')
        plt.xlabel('Интервалы')
        plt.ylabel(varlist[0])
        plt.grid(axis='y', alpha=0.75)
        plt.hist(a1[clnmb[0],:], 10)
    else:
        pass

    plt.tight_layout()
    canvas1 = FigureCanvasTkAgg(fig1, master=wind1)
    plot_widget1 = canvas1.get_tk_widget()
    plot_widget1.pack(expand=True, fill=BOTH)

    global plotnmb
    plotnmb = plotnmb +1
    if savegrfile:
        fig1.savefig('hystogr{}.png'.format(plotnmb))
    plt.close("all")

    wind1.mainloop()

#------------------------
def gr_scatter():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "2")
    nc = len(clnmb)
    global varlist
    if nc == 2:
        wind2 = Toplevel()
        wind2.title('Скатерограмма')
        wind2.resizable(True, True)
        w = wind2.winfo_screenwidth() // 2 - 380
        h = wind2.winfo_screenheight() // 2 - 220
        wind2.geometry('700x600+{}+{}'.format(w, h))

        # пустое окно для графиков
        fig2 = plt.figure()
        # Очистка, иначе может нарисовать другой график
        plt.clf()
        plt.xlabel(varlist[0])
        plt.ylabel(varlist[1])
        plt.grid(axis='y', alpha=0.75)
        plt.scatter(a1[clnmb[0], :], a1[clnmb[1], :])

        plt.tight_layout()
        canvas2 = FigureCanvasTkAgg(fig2, master=wind2)
        plot_widget2 = canvas2.get_tk_widget()
        plot_widget2.pack(expand=True, fill=BOTH)

        global plotnmb
        plotnmb = plotnmb + 1
        if savegrfile:
            fig2.savefig('scatter{}.png'.format(plotnmb))
        plt.close("all")

        wind2.mainloop()

#------------------------
def gr_scatter3d():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "3")
    nc = len(clnmb)
    global varlist
    if nc == 3:
        wind3 = Toplevel()
        wind3.title('Скатерограмма 3D')
        wind3.resizable(True, True)
        w = wind3.winfo_screenwidth() // 2 - 380
        h = wind3.winfo_screenheight() // 2 - 220
        wind3.geometry('700x600+{}+{}'.format(w, h))

        # пустое окно для графиков
        fig3 = plt.figure()
        ax = plt.axes(projection='3d')
        ax.scatter3D(a1[clnmb[0],:], a1[clnmb[1],:], a1[clnmb[2],:], c=a1[clnmb[2],:], cmap='Greens')
        ax.set_xlabel(varlist[0])
        ax.set_ylabel(varlist[1])
        ax.set_zlabel(varlist[2])

        plt.tight_layout()
        canvas3 = FigureCanvasTkAgg(fig3, master=wind3)
        plot_widget2 = canvas3.get_tk_widget()
        plot_widget2.pack(expand=True, fill=BOTH)

        global plotnmb
        plotnmb = plotnmb + 1
        if savegrfile:
            fig3.savefig('scatter3d{}.png'.format(plotnmb))
        plt.close("all")

        wind3.mainloop()

#=========================
def gr_series():
    a1 = np.load('array.npy')
    numcols = len(a1)

    # окно выбора переменных
    clnmb = currvar(numcols, False, "1-4")
    nc = len(clnmb)

    wind4 = Toplevel()
    wind4.title("Временной ряд")
    wind4.resizable(True, True)
    w = wind4.winfo_screenwidth() // 2 - 380
    h = wind4.winfo_screenheight() // 2 - 220
    wind4.geometry('700x600+{}+{}'.format(w, h))

    global varlist
    fig = plt.figure()
    # Очистка, иначе может нарисовать другой график
    plt.clf()

    # 4 графика одновременно
    if nc>1:
        for n in range(nc):
            if n==0:
                plt.subplot(3,1,1)
                plt.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
                plt.ylabel(varlist[0])
            elif n==1:
                plt.subplot(3,1,2)
                plt.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
                plt.ylabel(varlist[1])
            elif n==2:
                plt.subplot(3,1,3)
                plt.plot(range(1, len(a1[clnmb[n], :]) + 1), a1[clnmb[n], :])
                plt.ylabel(varlist[2])
                plt.xlabel('Последовательность')
            else:
                pass
    # 1 график на все окно
    elif nc==1:
        #plt.style.use('ggplot')
        plt.xlabel('Последовательность')
        plt.ylabel(varlist[0])
        plt.plot(range(1, len(a1[clnmb[0],:]) + 1), a1[clnmb[0],:])
    else:
        pass

    plt.tight_layout()
    canvas4 = FigureCanvasTkAgg(fig, master=wind4)
    plot_widget4 = canvas4.get_tk_widget()
    plot_widget4.pack(expand=True, fill=BOTH)

    global plotnmb
    plotnmb = plotnmb +1
    if savegrfile:
        fig.savefig('plot{}.png'.format(plotnmb))
    plt.close("all")

    wind4.mainloop()

#------------------------
def about():
    wind = Toplevel()
    wind.title('Fpyprog')
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 300
    h = wind.winfo_screenheight() // 2 - 50
    wind.geometry('320x180+{}+{}'.format(w, h))

    # для jpg нужны дополнительные ухищрения
    imgobj = PhotoImage(file='pic/ai2.png')

    global ver
    global date1
    st1 = ' Fpyprog'
    Label(wind, image=imgobj).pack(side=LEFT)
    Label(wind, text='').pack(side=TOP, anchor=W)
    Label(wind, text=st1, fg='dark blue', font="Arial 14 bold").pack(side=TOP, anchor=W)
    Label(wind, text='  Версия {}'.format(ver), fg='black', font="Arial 9").pack(side=TOP, anchor=W)
    Label(wind, text='  Белялов Ф.И.', fg='black', font="Arial 9").pack(side=TOP, anchor=W)
    Label(wind, text='  Иркутск, Россия', fg='black', font="Arial 9").pack(side=TOP, anchor=W)
    Label(wind, text='  {}'.format(date1), fg='black', font="Arial 9").pack(side=TOP, anchor=W)
    wind.mainloop()

#------------------------
def helpfile():
    wind = Toplevel()
    wind.title('Справка')
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 340
    h = wind.winfo_screenheight() // 2 - 150
    wind.geometry('520x360+{}+{}'.format(w, h))

    with open('readme.txt', 'r', encoding='utf-8') as myfile:
        data = myfile.read()

    # Vertical (y) Scroll Bar
    scroll = Scrollbar(wind)
    scroll.pack(side=RIGHT, fill=Y)

    # Text Widget
    eula = Text(wind, wrap=WORD, yscrollcommand=scroll.set)
    eula.insert("1.0", data)
    eula.pack(side="left")

    scroll.config(command=eula.yview)
    wind.mainloop()

# ------------------------
def link():
    webbrowser.open('http://webmed.irkutsk.ru/program.htm#a')

#------------------------
def config():
    def quit1():
        wind.withdraw()
        # causes mainloop to exit.
        wind.quit()

    wind = Toplevel()
    wind.title('Настройки')
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 300
    h = wind.winfo_screenheight() // 2 - 50
    wind.geometry('350x190+{}+{}'.format(w, h))

     #Размещение с помощью системы .grid, а не .pack(side=LEFT, expand=YES, fill=BOTH), где создается Frame для ряда
    file_dir = os.path.dirname(os.path.abspath(__file__))
    progpath = file_dir
    config1 = configparser.ConfigParser()
    cfgfile = progpath + '\Fpyprog.ini'
    config1.read(cfgfile)

    #читаем из файла конфигурации
    prgcat = config1.get('main', 'progcatalog')
    datcat = config1.get('main', 'datacatalog')
    global savegrfile
    savegrfile = config1.getboolean('main', 'savegrfile')
    global vast
    vast = config1.get('main', 'vast')

    #sticky = W for the Label, sticky = E for the Entry
    Label(wind, text='Каталог программы', justify=LEFT).grid(row=0, sticky=W)
    ent = Entry(wind, width=57)
    ent.grid(row=1)
    ent.insert(10, prgcat)

    Label(wind, text='Каталог данных', justify=LEFT).grid(row=2, sticky=W)
    ent1 = Entry(wind, width=57)
    ent1.grid(row=3)
    ent1.insert(10, datcat)

    Label(wind, text='Пустые значения', justify=LEFT).grid(row=4, sticky=W)
    ent2 = Entry(wind, width=57)
    ent2.grid(row=5)
    ent2.insert(10, vast)

    sgf = IntVar()
    chk1 = Checkbutton(wind, text='Сохранение графика в файл', variable=sgf, padx=2, pady=6)
    if savegrfile:
        chk1.select()
    else:
        chk1.deselect()
    chk1.grid(row=6, sticky=W)

    Button(wind, text="Ввод данных", command=quit1).grid(row=7)

    wind.mainloop()

    gf = sgf.get()
    savegrfile = bool(gf)
    int2str = str(gf)
    config1.read(cfgfile)
    config1.set('main', 'progcatalog', ent.get())
    config1.set('main', 'datacatalog', ent1.get())
    config1.set('main', 'savegrfile', int2str)
    config1.set('main', 'vast', ent2.get())

    with open(cfgfile, 'w') as f:
        config1.write(f)

#------------------------
def test():
    root = Toplevel()
    root.title('Тест')
    root.resizable(False, False)
    w = root.winfo_screenwidth() // 2 - 300
    h = root.winfo_screenheight() // 2 - 50
    root.geometry('200x100+{}+{}'.format(w, h))

    def quit1():
        root.withdraw()
        # causes mainloop to exit.
        root.quit()

    Label(root, text="").pack()

    #Checkbutton работает в основном окне, а здесь нет!
    var = tkinter.IntVar()
    Checkbutton(root, text='Сохранение в файле', variable=var).pack()

    Label(root, text='').pack()
    Button(root, text='Ввод данных', command=quit1).pack()

    root.mainloop()

    svfile = str(var.get())
    print(svfile)

# ------------------------
def clearout():
    global isclear
    answer = tkinter.messagebox.askquestion('Очистить результаты', 'Вы хотите удалить последние вычисления?')
    if answer == 'yes':
        open('output.txt', 'w').close() #Очистить файл вывода данных
        isclear = True
        printlog()
    else:
        pass

#------------------------
def close_prog():
    sys.exit()

#=========================
# (C) Adeyinka Adegbenro
class Calculator:
    def __init__(self, master):
        self.master = master
        master.title("Калькулятор")
        # create screen widget
        self.screen = Text(master, state='disabled', width=30, height=3, background='darkslategrey', foreground='white')

        # position screen in window
        self.screen.grid(row=0, column=0, columnspan=4, padx=4, pady=4)
        self.screen.configure(state='normal')

        # initialize screen value as empty
        self.equation = ''

        # create buttons using method createButton
        b1 = self.createButton(7)
        b2 = self.createButton(8)
        b3 = self.createButton(9)
        b4 = self.createButton(u"\u232B", None)
        b5 = self.createButton(4)
        b6 = self.createButton(5)
        b7 = self.createButton(6)
        b8 = self.createButton(u"\u00F7")
        b9 = self.createButton(1)
        b10 = self.createButton(2)
        b11 = self.createButton(3)
        b12 = self.createButton('*')
        b13 = self.createButton('.')
        b14 = self.createButton(0)
        b15 = self.createButton('+')
        b16 = self.createButton('-')
        b17 = self.createButton('=', None, 34)

        # buttons stored in list
        buttons = [b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12, b13, b14, b15, b16, b17]

        # intialize counter
        count = 0
        # arrange buttons with grid manager
        for row in range(1, 5):
            for column in range(4):
                # button = Button(self.master, command=self.click,width)
                buttons[count].grid(row=row, column=column)
                count += 1
        # arrange last button '=' at the bottom
        buttons[16].grid(row=5, column=0, columnspan=4, padx=2, pady=2)

    def createButton(self, val, write=True, width=7):
        # this function creates a button, and takes one compulsory argument, the value that should be on the button
        return Button(self.master, text=val, command=lambda: self.click(val, write), width=width)

    def click(self, text, write):
         # 'write' True means the value 'val' should be written on screen, if None, should not be written on screen
        if write == None:
            # only evaluate code when there is an equation to be evaluated
            if text == '=' and self.equation:
                # replace the unicode value of division ./.with python division symbol / using regex
                self.equation = re.sub(u"\u00F7", '/', self.equation)
                answer = str(eval(self.equation))
                self.clear_screen()
                self.insert_screen(answer, newline=True)
            elif text == u"\u232B":
                self.clear_screen()
        else:
            self.insert_screen(text)

    def clear_screen(self):
        # to clear screen
        # set equation to empty before deleting screen
        self.equation = ''
        self.screen.configure(state='normal')
        self.screen.delete('1.0', END)

    def insert_screen(self, value, newline=False):
        self.screen.configure(state='normal')
        self.screen.insert(END, value)
        # record every value inserted in screen
        self.equation += str(value)
        self.screen.configure(state='disabled')

def calculator1():
    wind = Toplevel()
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 300
    h = wind.winfo_screenheight() // 2 - 50
    wind.geometry('252x196+{}+{}'.format(w, h))
    wind.config(bg="light grey")

    Calculator(wind)
    wind.mainloop()

#=========================
# from pyknow import * приводит к проблемам размещения grid
# Доработал пример expert-system-children_diabetes
from pyknow import Fact, Rule, KnowledgeEngine, MATCH, AS, TEST, P
def expert():
    class Headache(Fact):
        """Info about the patient"""
        pass

    def SUMFIELDS(p, *fields):
        return sum([p.get(x, 0) for x in fields])

    class InreferenceEngine(KnowledgeEngine):

        @Rule(Headache(age=MATCH.age))
        def adult(self, age):
            if age < 18:
                self.declare(Fact(children=True))
                print("")
                print("Алгоритмы не для детей!")
            else:
                self.declare(Fact(children=False))

        @Rule(AS.p << Headache(),
              TEST(lambda p: SUMFIELDS(p,
                                       'fever',
                                       'neck_stiffness') > 1)
              )
        def has_meningitis(self, p):
            self.declare(Fact(has_meningitis=True))

        @Rule(Fact(has_meningitis=True))
        def risk_meningitis(self):
           print("")
           print("Ds: Менингит")


        @Rule(Headache(duration=MATCH.duration))
        def episodic_type(self, duration):
            if duration < 15:
                self.declare(Fact(episodic=True))
            else:
                self.declare(Fact(episodic=False))

        @Rule(Headache(nausea=MATCH.nausea))
        def has_nausea(self, nausea):
            if nausea == True:
                self.declare(Fact(has_nausea=True))
            else:
                self.declare(Fact(has_nausea=False))

        @Rule(Headache(light_sensitivity=MATCH.light_sensitivity))
        def has_light_sensitivity(self, light_sensitivity):
            if light_sensitivity == True:
                self.declare(Fact(has_light_sensitivity=True))
            else:
                self.declare(Fact(has_light_sensitivity=False))

        @Rule(Headache(worsened_by_activity=MATCH.worsened_by_activity))
        def has_worsened_by_activity(self, worsened_by_activity):
            if worsened_by_activity == True:
                self.declare(Fact(has_worsened_by_activity=True))
            else:
                self.declare(Fact(has_worsened_by_activity=False))

        @Rule(Headache(pulsating=MATCH.pulsating))
        def has_pulsating(self, pulsating):
            if pulsating == True:
                self.declare(Fact(has_pulsating=True))
            else:
                self.declare(Fact(has_pulsating=False))

        @Rule(Fact(episodic=True),
              Fact(has_nausea=False),
              Fact(has_light_sensitivity=False),
              Headache(bilateral=True),
              Fact(has_worsened_by_activity=False),
              Fact(has_pulsating=False))
        def tension_headache(self):
            self.declare(Fact(tension=True))
            print("")
            print(" Ds: Эпизодическая головная боль напряжения")

        @Rule(Fact(episodic=False),
              Fact(has_nausea=False),
              Fact(has_light_sensitivity=False),
              Headache(bilateral=True),
              Fact(has_worsened_by_activity=False),
              Fact(has_pulsating=False))
        def tension_headache1(self):
            self.declare(Fact(tension1=True))
            print("")
            print(" Ds: Хроническая головная боль напряжения")

        @Rule(Fact(episodic=True),
              Fact(has_nausea=True),
              Headache(bilateral=False),
              Fact(has_light_sensitivity=True))
        def episodic_migraine(self):
            self.declare(Fact(epmigrain=True))
            print("")
            print(" Ds: Эпизодическая мигрень")


        @Rule(Fact(episodic=False),
              Fact(has_nausea=True),
              Headache(bilateral=False),
              Fact(has_light_sensitivity=True))
        def chronic_migraine(self):
            self.declare(Fact(chrmigrain=True))
            print("")
            print(" Ds: Хроническая мигрень")


    def quit1():
        wind.withdraw()
        # causes mainloop to exit.
        wind.quit()

    wind = Toplevel()
    wind.title('Экспертная система')
    wind.resizable(False, False)
    w = wind.winfo_screenwidth() // 2 - 300
    h = wind.winfo_screenheight() // 2 - 150
    wind.geometry('230x340+{}+{}'.format(w, h))

    Label(wind, text="Головная боль", font="Arial 10 bold").pack(side=TOP)

    Label(wind, text="Локализация", justify=LEFT).pack(side=TOP, anchor=W)
    # нельзя прикрепить scrollbar к listbox, только к окну
    data = ('односторонняя', 'двустороняя', 'лобная', 'периорбитальная', 'затылочная')
    cmbbox=ttk.Combobox(wind,values=data,width=18)
    cmbbox.pack(fill=X)
    cmbbox.current(0)

    Label(wind, text='Длительность, сут', justify=LEFT).pack(side=TOP, anchor=W)
    ent = Entry(wind, width=20)
    ent.pack(side=TOP, fill=X, anchor=W, padx=2)
    ent.insert(10, 2)

    Label(wind, text='Возраст, годы', justify=LEFT).pack(side=TOP, anchor=W)
    ent1 = Entry(wind, width=20)
    ent1.pack(side=TOP, fill=X, anchor=W, padx=2)
    ent1.insert(10, 20)

    c1 = IntVar()
    Checkbutton(wind, text='Тошнота', variable=c1, padx=2, pady=2).pack(side=TOP, anchor=W)
    c2 = IntVar()
    Checkbutton(wind, text='Усиление при активности', variable=c2, padx=2, pady=2).pack(side=TOP, anchor=W)
    c3 = IntVar()
    Checkbutton(wind, text='Пульсирующая', variable=c3, padx=2, pady=2).pack(side=TOP, anchor=W)
    c4 = IntVar()
    Checkbutton(wind, text='Чувствительность к свету', variable=c4, padx=2, pady=2).pack(side=TOP, anchor=W)
    c5 = IntVar()
    Checkbutton(wind, text='Лихорадка', variable=c5, padx=2, pady=2).pack(side=TOP, anchor=W)
    c6 = IntVar()
    Checkbutton(wind, text='Напряжение затылочных мышц', variable=c6, padx=2, pady=2).pack(side=TOP, anchor=W)

    Button(wind, text='Ввод данных', command=quit1).pack(side=TOP)

    wind.mainloop()

    cl = cmbbox.current()
    # иногда ошибка tuple index out of range error related to curselection (tkinter)
    if cmbbox.get()!="":
        if cl <1:
            bilateralloc = False
        else:
            bilateralloc = True

        durat = int(ent.get())
        age1 = int(ent1.get())

        nausea1 = bool(c1.get())
        worsened_by_activity1 = bool(c2.get())
        pulsating1 = bool(c3.get())
        light_sensitivity1 = bool(c4.get())
        fever1 = bool(c5.get())
        neck_stiffness1 = bool(c6.get())

        engine = InreferenceEngine()
        engine.reset()
        engine.declare(Headache(age=age1,
                                duration=durat,
                                bilateral=bilateralloc,
                                nausea=nausea1,
                                worsened_by_activity=worsened_by_activity1,
                                pulsating=pulsating1,
                                light_sensitivity=light_sensitivity1,
                                fever=fever1,
                                neck_stiffness=neck_stiffness1
                                ))
        engine.run()
    else:
        tkinter.messagebox.showinfo("def expert()", "Ошибка выбора cl = listbox.curselection()[0]")
#=========================
class MenuToolbar(Frame):
    def __init__(self, parent):
        Frame.__init__(self, parent)
        self.parent = parent
        self.initui()

    def initui(self):
        menubar = Menu(self.parent)
        filemenu = Menu(menubar, tearoff=0)
        filemenu.add_command(label='Открыть файл данных', command=fileopen)
        filemenu.add_command(label='Открыть любой файл', command=fileopen1)
        filemenu.add_command(label='Информация базы данных', command=dbinfo)
        filemenu.add_separator()
        filemenu.add_command(label='Выход', command=close_prog)
        menubar.add_cascade(label='Файлы', menu=filemenu)

        datamenu = Menu(menubar, tearoff=0)
        datamenu.add_command(label='Текущий массив', command=curarray)
        datamenu.add_command(label='Открыть сохраненные данные', command=datafileopen)
        datamenu.add_command(label='Удалить выбросы', command=deleteoutliers)
        datamenu.add_command(label='Удалить пропуски', command=deletevast)
        datamenu.add_separator()
        datamenu.add_command(label='Очистить результаты', command=clearout)
        menubar.add_cascade(label='Данные', menu=datamenu)

        statmenu = Menu(menubar, tearoff=0)
        statmenu.add_command(label='Статистика', command=statistics)
        statmenu.add_command(label='Корреляция Pearson ', command=pearson)
        statmenu.add_command(label='Корреляция Spearman', command=spearmen)
        statmenu.add_command(label='t-тест Student', command=student)
        statmenu.add_command(label='Кластерный анализ', command=cluster)
        statmenu.add_command(label='Экспертная система', command=expert)
        statmenu.add_separator()
        statmenu.add_command(label='Калькулятор', command=calculator1)
        menubar.add_cascade(label='Вычисления', menu=statmenu)

        grmenu = Menu(menubar, tearoff=0)
        grmenu.add_command(label='Гистограмма', command=gr_hystogr)
        grmenu.add_command(label='Скатерограмма', command=gr_scatter)
        grmenu.add_command(label='Временной ряд', command=gr_series)
        grmenu.add_command(label='3D скатерограмма', command=gr_scatter3d)
        menubar.add_cascade(label='Графики', menu=grmenu)

        helpmenu = Menu(menubar, tearoff=0)
        helpmenu.add_command(label='Настройка', command=config)
        helpmenu.add_command(label='Справка', command=helpfile)
        helpmenu.add_command(label='Сайт', command=link)
        helpmenu.add_command(label='О программе', command=about)
        menubar.add_cascade(label='Инструменты', menu=helpmenu)

        #-----------------------
        toolbar = Frame(self.parent, bd=1, relief=RAISED)
        self.img1 = Image.open('pic/folder.png')
        eimg1 = ImageTk.PhotoImage(self.img1)
        openbutton = Button(toolbar, image=eimg1, relief=FLAT, command=fileopen)
        openbutton.image = eimg1
        openbutton.pack(side=LEFT, padx=2, pady=2)

        self.img2 = Image.open('pic/array.png')
        eimg2 = ImageTk.PhotoImage(self.img2)
        arbutton = Button(toolbar, image=eimg2, relief=FLAT, command=curarray)
        arbutton.image = eimg2
        arbutton.pack(side=LEFT, padx=2, pady=2)

        self.img3 = Image.open('pic/calculatefull.png')
        eimg3 = ImageTk.PhotoImage(self.img3)
        statbutton = Button(toolbar, image=eimg3, relief=FLAT, command=calculator1)
        statbutton.image = eimg3
        statbutton.pack(side=LEFT, padx=2, pady=2)

        self.img4 = Image.open('pic/graph.png')
        eimg4 = ImageTk.PhotoImage(self.img4)
        grbutton = Button(toolbar, image=eimg4, relief=FLAT, command=gr_hystogr)
        grbutton.image = eimg4
        grbutton.pack(side=LEFT, padx=2, pady=2)

        self.img5 = Image.open('pic/exit.png')
        eimg5 = ImageTk.PhotoImage(self.img5)
        exitbutton = Button(toolbar, image=eimg5, relief=FLAT, command=close_prog)
        exitbutton.image = eimg5
        exitbutton.pack(side=LEFT, padx=2, pady=2)

        toolbar.pack(side=TOP, fill=X)
        self.parent.config(menu=menubar)
        self.pack()

    def onExit(self):
        self.quit()

def main():
    # Создаем корневое окно - всегда одно в программе, окон Toplevel сколько хотите.
    windmain = Tk()
    global ver
    windmain.title('Fpyprog {}'.format(ver))
    windmain.resizable(True, True)
    w = windmain.winfo_screenwidth() // 2 - 450
    h = windmain.winfo_screenheight() // 2 - 200
    windmain.geometry('600x420+{}+{}'.format(w, h))

    app = MenuToolbar(windmain)
    text = TextOut(windmain)
    sys.stdout = text

    scrollV = tk.Scrollbar(windmain, orient=tk.VERTICAL)
    scrollV.config(command=text.yview)
    text.configure(yscrollcommand=scrollV.set)
    scrollV.pack(side=tk.RIGHT, fill=tk.Y)
    text.pack(expand=True, fill=BOTH)

    #считываем из файла конфиргурации
    progpath = os.path.dirname(os.path.abspath(__file__))
    config = configparser.ConfigParser()
    cfgfile = progpath + '\Fpyprog.ini'
    config.read(cfgfile)

    global vast  
    #Пропуски
    vast = config.get('main', 'vast')
    # Сохранение графиков
    global savegrfile
    savegrfile = config.getboolean('main', 'savegrfile')

    windmain.mainloop()

if __name__ == '__main__':
    main()
